﻿@using System.Web.UI.WebControls
@{
    ViewBag.Title = "Index";

    List<SelectListItem> statusDropdownList = (List<SelectListItem>)ViewBag.ReceiptStatusList;
    List<SelectListItem> channelList = (List<SelectListItem>)ViewBag.ChannelList;
    List<SelectListItem> spgCodeList = (List<SelectListItem>)ViewBag.SPGCodeList;
    List<SelectListItem> eventCodeList = (List<SelectListItem>)ViewBag.EventCodeList;
    List<SelectListItem> retailerList = (List<SelectListItem>)ViewBag.ListRetailer;
    List<SelectListItem> retailerHasAddr = new List<SelectListItem>();
    retailerHasAddr.Add(new SelectListItem() { Text = "Blank", Value = "blank" });
    retailerHasAddr.Add(new SelectListItem() { Text = "Not Blank", Value = "not" });
}

<!--=== Page Header ===-->
<div class="page-header">
    <div class="page-title">
        <h3>Receipt</h3>
    </div>
    <!-- Page Stats -->
    <ul class="page-stats">
        @*  <li>
                <a href="@Url.Action(MVC.Receipt.UploadFromExel())" class="btn btn-icon input-block-level">
                    <i class="icon-group"></i>
                    <div>Add From Excel</div>
                </a>
            </li>*@
        <li>
            <a href="@Url.Action(MVC.Receipt.Add())" class="btn btn-icon input-block-level">
                <i class="icon-group"></i>
                <div>Add Receipt</div>
            </a>
        </li>
    </ul>
    <!-- /Page Stats -->
</div>
<!-- /Page Header -->

<div class="row">
    <!--=== Validation Example 1 ===-->
    <div class="col-md-6 pull-right">
        <div class="widget box">
            <div class="widget-content">
                @using (Html.BeginForm("Index", "Receipt", FormMethod.Post, new { @class = "form-horizontal row-border", @id = "formSearchReceipt" }))
                {
                    @Html.AntiForgeryToken()
                    <div class="form-horizontal row-border">
                        <div class="form-group">
                            <label class="col-md-3 control-label">Member </label>
                            <div class="col-md-6">
                                @Html.Hidden("memberIDHidden", "")
                                @Html.TextBox("MemberName", "", new { @class = "form-control", @readonly = "" })
                                <button type="button" class="col-md-3 btn btn-warning" data-toggle="modal" data-target="#memberModal" data-whatever="lala" style="width: 226px">Select Member</button>
                            </div>
                        </div>
                    </div>
                    <div class="form-horizontal row-border">
                        <div class="form-group">
                            <label class="col-md-3 control-label">Tgl Awal <span class="required">*</span></label>
                            <div class="col-md-6">
                                @Html.TextBox("hiddenAwal", "", new { @class = "form-control datepicker2", @required = "" })
                            </div>
                        </div>
                    </div>
                    <div class="form-horizontal row-border">
                        <div class="form-group">
                            <label class="col-md-3 control-label">Tgl Akhir <span class="required">*</span></label>
                            <div class="col-md-6">
                                @Html.TextBox("hiddenAkhir", "", new { @class = "form-control datepicker2", @required = "" })
                            </div>
                        </div>
                    </div>
                    <div class="form-horizontal row-border">
                        <div class="form-group">
                            <label class="col-md-3 control-label">Status </label>
                            <div class="col-md-6">
                                @Html.DropDownList("statusHidden", statusDropdownList, "", new { @class = "form-control" })
                            </div>
                        </div>
                    </div>
                    <div class="form-horizontal row-border">
                        <div class="form-group">
                            <label class="col-md-3 control-label">Retailer </label>
                            <div class="col-md-6">
                                @Html.DropDownList("retailerHidden", retailerList, "", new { @class = "form-control" })
                            </div>
                        </div>
                    </div>
                    <div class="form-horizontal row-border">
                        <div class="form-group">
                            <label class="col-md-3 control-label">Retailer Address </label>
                            <div class="col-md-6">
                                @Html.DropDownList("retailerHasHidden", retailerHasAddr, "", new { @class = "form-control" })
                            </div>
                        </div>
                    </div>
                    <div class="form-horizontal row-border">
                        <div class="form-group">
                            <label class="col-md-3 control-label">Channel </label>
                            <div class="col-md-6">
                                @Html.DropDownList("channelHidden", channelList, "", new { @class = "form-control" })
                            </div>
                        </div>
                    </div>
                    <div class="form-horizontal row-border">
                        <div class="form-group">
                            <label class="col-md-3 control-label">SPG Code </label>
                            <div class="col-md-6">
                                @Html.DropDownList("spgCodeHidden", spgCodeList, "", new { @class = "form-control" })
                            </div>
                        </div>
                    </div>
                    <div class="form-horizontal row-border">
                        <div class="form-group">
                            <label class="col-md-3 control-label">Kode Event </label>
                            <div class="col-md-6">
                                @Html.DropDownList("eventCodeHidden", eventCodeList, "", new { @class = "form-control" })
                            </div>
                        </div>
                    </div>
                    <div class="form-actions">
                        <input type="submit" value="Download" class="btn btn-primary pull-right" id="download-button-reporting">
                        <input type="button" value="Search" class="btn btn-primary pull-right" id="search-button-reporting">
                    </div>
                }
            </div>
        </div>
    </div>
</div>

<div class="row">
    <div class="col-md-12">
        <div id="gridGetAllReceiptPager" class="widget">
            @*<div class="widget-header">
                    <h4><i class="icon-reorder"></i> All Receipt</h4>
                </div>
                <div class="right-title">
                    @using (Html.BeginForm(null, null, null, FormMethod.Post, new { id = "gridSeachReceipt", Receipt = "form" }))
                    {
                        <input type="text" id="txtSearch" name="txtSearch" class="form-control box-search" placeholder="Search for...">
                        <input type="text" id="hiddenAwal" name="hiddenAwal" class="form-control box-search" style="display: none">
                        <input type="text" id="hiddenAkhir" name="hiddenAkhir" class="form-control box-search" style="display: none">
                        <input type="text" id="memberIDHidden" name="memberIDHidden" class="hidden" style="display: none">
                        <input type="text" id="statusHidden" name="statusHidden" class="hidden" style="display: none">
                        <input type="text" id="channelHidden" name="channelHidden" class="hidden" style="display: none">
                        <button id="hidden-search-form" class="hidden" type="submit"></button>
                    }
                </div>
                <div class="widget-content">

                </div>*@
            @Html.Action("GridGetAllReceiptPager", new { page = 1 })
            <!-- .box-content -->
        </div>
        <!-- .box -->
    </div>
</div>

<div class="modal fade" id="memberModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel">
    <div class="modal-dialog" style="width: auto !important" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Select Member</h4>
            </div>
            <div class="modal-body">
                @Html.Action("GridGetSelectMemberPager", "Member", new { page = 1 })
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>

@section FooterScript{
    <script>
        $(document).ready(function () {
            var gridName = 'AllReceipt';
            var pagingUrl = '@Url.Action(MVC.Receipt.GridGetAllReceiptPager())';

            $.extend($.validator.defaults, {
                invalidHandler: function (form, validator) {
                    var errors = validator.numberOfInvalids();
                    if (errors) {
                        var message = errors == 1
                            ? 'You missed 1 field. It has been highlighted.'
                            : 'You missed ' + errors + ' fields. They have been highlighted.';
                        noty({
                            text: message,
                            type: 'error',
                            timeout: 2000
                        });
                    }
                },
                errorPlacement: function (error, element) {
                    if (element.attr('type') === "file" && element.data('style') === "fileinput") {
                        error.appendTo(element.closest("div.fileinput-holder").parent('div'));
                    } else {
                        error.insertAfter(element)
                    }
                }
            });

            //$('.grid-mvc').gridmvc();
            //pageGrids[gridName].ajaxify({
            //    getData: pagingUrl,
            //    getPagedData: pagingUrl,
            //    gridFilterForm: $('#gridSeachReceipt'),
            //    onAjaxComplete: function () { }
            //});

            $('#search-button-reporting').click(function () {
                // alert('aaa')

                //var awal = $('#tglAwal').val();
                //var akhir = $('#tglAkhir').val();
                //var MemberID = $('#MemberID').val();
                //var status = $('#Status').val();
                //var channel = $('#Channel').val();
                //$('#hiddenAwal').val(awal);
                //$('#hiddenAkhir').val(akhir);
                //$('#memberIDHidden').val(MemberID)
                //$('#statusHidden').val(status);
                //$('#channelHidden').val(channel);
                //$('#hidden-search-form').click();
                console.log($('#formSearchReceipt').serialize())
            });

            $('#download-button-reporting').click(function () {
                setTimeout(function () { HideLoader(); }, 3000);
            });

            $(".datepicker2").datepicker({
                defaultDate: +7,
                showOtherMonths: true,
                autoSize: true,
                dateFormat: 'dd/mm/yy',
            });

            function LoadGridFunctions() {
                function LoadData(dataUrl) {
                    if (dataUrl) {
                        $.ajax({
                            url: dataUrl,
                            complete: function (xhr, status) {
                                if (status === 'success') {
                                    $('div#gridGetAllReceiptPager.widget').html(xhr.responseText);
                                } else {
                                    alert(status + ' : ' + xhr.responseText);
                                }
                                LoadGridFunctions();
                            }
                        })
                    }
                }

                $('div.grid-header-title > a, .grid-footer ul.pagination li > a').on('click', function (e) {
                    e.preventDefault();
                    var dataUrl = $(this).data('url');
                    LoadData(dataUrl);
                })

                $('form[name=gridForm]').on('submit', function (e) {
                    e.preventDefault();
                    //e.stopPropagation();
                    var formArray = $('#formSearchReceipt').serializeArray();
                    formArray.push({ name: 'txtSearch', value: $('input[name=txtSearch]').val() });
                    LoadData('@Url.Action(MVC.Receipt.GridGetAllReceiptPager())?' + serializeArrayToQuery(formArray));
                })

                $('#search-button-reporting').off('click')
                $('#search-button-reporting').on('click', function () {
                    if ($("#formSearchReceipt").valid()) {
                        //var dataUrl = '@Url.Action(MVC.Receipt.GridGetAllReceiptPager())?' + $('#formSearchReceipt').serialize();
                        var formArray = $('#formSearchReceipt').serializeArray();
                        formArray.push({ name: 'txtSearch', value: $('input[name=txtSearch]').val() });
                        LoadData('@Url.Action(MVC.Receipt.GridGetAllReceiptPager())?' + serializeArrayToQuery(formArray));
                    }
                });
            }
            LoadGridFunctions();

            function LoadGridMemberFunctions() {
                function LoadData(dataUrl) {
                    if (dataUrl) {
                        $.ajax({
                            url: dataUrl,
                            complete: function (xhr, status) {
                                if (status === 'success') {
                                    $('div#memberModal .modal-body').html(xhr.responseText);
                                } else {
                                    alert(status + ' : ' + xhr.responseText);
                                }
                                LoadGridMemberFunctions();
                            }
                        })
                    }
                }

                $('#grid-select-member div.grid-header-title > a, #grid-select-member .grid-footer ul.pagination li > a').on('click', function (e) {
                    e.preventDefault();
                    var dataUrl = $(this).data('url');
                    LoadData(dataUrl);
                })

                $('form[name=grid-select-member-form]').on('submit', function (e) {
                    e.preventDefault();
                    //e.stopPropagation();
                    HideLoader();
                    var dataUrl = decodeURIComponent($(this).find('[type=hidden][name=rawDataUrl]').val()).replace('@@search@@', $(this).find('[type=text][name=txtSearch]').val());
                    LoadData(dataUrl);
                })
            }
            LoadGridMemberFunctions();
        })

        function serializeArrayToQuery(objArr) {
            if (Array.isArray(objArr)) {
                var strArr = [];
                for (var i = 0; i < objArr.length; i++) {
                    var item = objArr[i];
                    strArr.push(item.name + '=' + item.value)
                }
                return strArr.join('&');
            }
            return null;
        }

        //function ini dipanggil sama popup Member
        function SelectMember(MemberID, MemberName) {
            $('#memberIDHidden').val(MemberID);
            $('#MemberName').val(MemberName);
            $('#memberModal').modal('hide');
            //_url = '';
            //$.ajax({
            //    url: _url,
            //    success: function (msg) {
            //        $('#MaxPoint').val(msg.points)
            //    },
            //    error: function (jqXHR, textStatus) {
            //        alert('Error Occured');
            //    }
            //})
        };
    </script>
}